com.smartgwt.client.types

## Enum ExpansionMode

- java.lang.Object
- - java.lang.Enum<ExpansionMode>
  - - com.smartgwt.client.types.ExpansionMode

- All Implemented Interfaces:
    ValueEnum, java.io.Serializable, java.lang.Comparable<ExpansionMode>

      public enum ExpansionMode
      extends java.lang.Enum<ExpansionMode>
      implements ValueEnum

  When `canExpandRecords` is true, ExpansionMode dictates the type of UI to be displayed in the expanded portion of the row.

  There are a number of builtin ExpansionModes and you can override `getExpansionComponent()` to create your own expansion behaviors.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DETAIL_FIELD` Show a single field's value in an `HTMLFlow`.
    `DETAIL_RELATED` Show a `DetailViewer` displaying those fields from the record not already displayed in the grid, together with a separate `ListGrid` containing related-records.
    `DETAILS` Show a `DetailViewer` displaying those fields from the record which are not already displayed in the grid.
    `EDITOR` Show a `DynamicForm` to edit those fields from the record which are not already present in the grid.
    `RELATED` Show a separate `ListGrid` containing related-records.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getValue()`
    `static ExpansionMode` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static ExpansionMode[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### DETAIL_FIELD

          public static final ExpansionMode DETAIL_FIELD

      Show a single field's value in an `HTMLFlow`. Field to use is `detailField`.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "detailField".

    - #### DETAILS

          public static final ExpansionMode DETAILS

      Show a `DetailViewer` displaying those fields from the record which are not already displayed in the grid.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "details".

    - #### RELATED

          public static final ExpansionMode RELATED

      Show a separate `ListGrid` containing related-records. See `detailDS` and `recordDetailDSProperty` for more information.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "related".

    - #### EDITOR

          public static final ExpansionMode EDITOR

      Show a `DynamicForm` to edit those fields from the record which are not already present in the grid. If the record is collapsed with unsaved changes and `expansionEditorShowSaveDialog` is not set, Edits will be saved automatically, or stored as `editValues` if `autoSaveEdits` is false. Otherwise, a confirmation dialog is displayed. Can optionally show a `save button` and `auto-collapse` when save is pressed. If a record fails validation on save and the field in question is not visible in the grid, the record is automatically expanded and validated to show the errors.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "editor".

    - #### DETAIL_RELATED

          public static final ExpansionMode DETAIL_RELATED

      Show a `DetailViewer` displaying those fields from the record not already displayed in the grid, together with a separate `ListGrid` containing related-records.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "detailRelated".

  - ### Method Detail

    - #### values

          public static ExpansionMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ExpansionMode c : ExpansionMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ExpansionMode valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getValue

          public java.lang.String getValue()

      Specified by:
        `getValue` in interface `ValueEnum`